#lang racket

(require 2htdp/image)
(require scheme/foreign)
(require vigracket/carray)
(require (only-in vigracket/helpers 
          float->uint8))

(define (plt-image->image img)
  (let* ((*img_col* (image->color-list img))
         (*red*   (map (lambda(x) (exact->inexact (color-red x)))  *img_col*))
         (*green* (map (lambda(x) (exact->inexact (color-green x))) *img_col*))
         (*blue*  (map (lambda(x) (exact->inexact (color-blue x)))  *img_col*)))
    (if (foldl (lambda (x y) (and x y)) 
               #t 
               (map = *red* *green* *blue*))
        (list (make-carray-base (list->cvector *red* _float) (list (image-width img) (image-height img))))
        (list (make-carray-base (list->cvector *red* _float) (list (image-width img) (image-height img)))
              (make-carray-base (list->cvector *green* _float) (list (image-width img) (image-height img)))
              (make-carray-base (list->cvector *blue* _float) (list (image-width img) (image-height img)))))))

(define (image->plt-image img)
  (if (= 1 (length img))
      ;Grayscale
      (let* ((lst (cvector->list (carray-data (car img))))
             (color_list (map (lambda (x) (make-color x x x)) (map float->uint8 lst))))
        (color-list->bitmap color_list (first  (carray-dimensions (car img)))
                                      (second (carray-dimensions (car img)))))
      ;Color
      (let* ((r_lst (map float->uint8 (cvector->list (carray-data (first img)))))
             (g_lst (map float->uint8 (cvector->list (carray-data (second img)))))
             (b_lst (map float->uint8 (cvector->list (carray-data (third img)))))
             (color_list (map  make-color r_lst g_lst b_lst)))
        (color-list->bitmap color_list (first  (carray-dimensions (car img)))
                                       (second (carray-dimensions (car img)))))))
      
(provide plt-image->image
         image->plt-image)